# AUTO-GENERATED FILE. Do not edit.
from enum import Enum


class MetricKind(str, Enum):
    # statistics about features that were outputs of a query
    # or live-computed
    FEATURE_REQUEST_COUNT = "FEATURE_REQUEST_COUNT"
    FEATURE_LATENCY = "FEATURE_LATENCY"
    FEATURE_STALENESS = "FEATURE_STALENESS"
    FEATURE_VALUE = "FEATURE_VALUE"
    FEATURE_WRITE = "FEATURE_WRITE"
    FEATURE_NULL_RATIO = "FEATURE_NULL_RATIO"
    # Statistics about features computed by resolvers
    FEATURE_COMPUTED_COUNT = "FEATURE_COMPUTED_COUNT"
    FEATURE_COMPUTED_NULL_RATIO = "FEATURE_COMPUTED_NULL_RATIO"
    # statistics about features looked up from the online store during a query
    FEATURE_LOOKED_UP_COUNT = "FEATURE_LOOKED_UP_COUNT"
    FEATURE_LOOKED_UP_NULL_RATIO = "FEATURE_LOOKED_UP_NULL_RATIO"
    # statistics about features whose values were produced during a query
    # either computed OR looked up. Differs from request_count as they do
    # not necessarily need to be requested as an output.
    FEATURE_INTERMEDIATE_COUNT = "FEATURE_INTERMEDIATE_COUNT"
    FEATURE_INTERMEDIATE_NULL_RATIO = "FEATURE_INTERMEDIATE_NULL_RATIO"

    RESOLVER_REQUEST_COUNT = "RESOLVER_REQUEST_COUNT"
    RESOLVER_LATENCY = "RESOLVER_LATENCY"
    RESOLVER_SUCCESS_RATIO = "RESOLVER_SUCCESS_RATIO"

    QUERY_COUNT = "QUERY_COUNT"
    QUERY_LATENCY = "QUERY_LATENCY"
    QUERY_SUCCESS_RATIO = "QUERY_SUCCESS_RATIO"

    BILLING_INFERENCE = "BILLING_INFERENCE"
    BILLING_CRON = "BILLING_CRON"
    BILLING_MIGRATION = "BILLING_MIGRATION"

    CRON_COUNT = "CRON_COUNT"
    CRON_LATENCY = "CRON_LATENCY"

    STREAM_MESSAGES_PROCESSED = "STREAM_MESSAGES_PROCESSED"
    STREAM_MESSAGE_LATENCY = "STREAM_MESSAGE_LATENCY"

    STREAM_WINDOWS_PROCESSED = "STREAM_WINDOWS_PROCESSED"
    STREAM_WINDOW_LATENCY = "STREAM_WINDOW_LATENCY"

    STREAM_LAG = "STREAM_LAG"

    ONLINE_STORE_USED_MEMORY = "ONLINE_STORE_USED_MEMORY"
    ONLINE_STORE_KEY_COUNT = "ONLINE_STORE_KEY_COUNT"
    ONLINE_STORE_EXPIRED_KEY_COUNT = "ONLINE_STORE_EXPIRED_KEY_COUNT"
    ONLINE_STORE_REQUESTS_PER_SECOND = "ONLINE_STORE_REQUESTS_PER_SECOND"
    ONLINE_STORE_TOTAL_MEMORY = "ONLINE_STORE_TOTAL_MEMORY"

    # Usage
    USAGE = "USAGE"

    #
    CPU_UTILIZATION_PERCENT = "CPU_UTILIZATION_PERCENT"
    MEMORY_USAGE_BYTES = "MEMORY_USAGE_BYTES"
    TOTAL_MEMORY_AVAILABLE_BYTES = "TOTAL_MEMORY_AVAILABLE_BYTES"
    NETWORK_READ_BYTES = "NETWORK_READ_BYTES"
    NETWORK_WRITE_BYTES = "NETWORK_WRITE_BYTES"
    DISK_READ_BYTES = "DISK_READ_BYTES"
    DISK_WRITE_BYTES = "DISK_WRITE_BYTES"

    REPLICA_COUNT = "REPLICA_COUNT"


class FilterKind(str, Enum):
    FEATURE_STATUS = "FEATURE_STATUS"
    FEATURE_NAME = "FEATURE_NAME"
    FEATURE_TAG = "FEATURE_TAG"

    RESOLVER_STATUS = "RESOLVER_STATUS"
    RESOLVER_NAME = "RESOLVER_NAME"
    RESOLVER_TAG = "RESOLVER_TAG"

    CRON_STATUS = "CRON_STATUS"
    MIGRATION_STATUS = "MIGRATION_STATUS"

    ONLINE_OFFLINE = "ONLINE_OFFLINE"
    CACHE_HIT = "CACHE_HIT"
    OPERATION_ID = "OPERATION_ID"

    QUERY_NAME = "QUERY_NAME"
    QUERY_STATUS = "QUERY_STATUS"

    IS_NULL = "IS_NULL"

    USAGE_KIND = "USAGE_KIND"

    COMPUTATION_CONTEXT = "COMPUTATION_CONTEXT"
    RESOURCE_GROUP = "RESOURCE_GROUP"

    POD_NAME = "POD_NAME"


class ComparatorKind(str, Enum):
    EQ = "EQ"
    NEQ = "NEQ"
    ONE_OF = "ONE_OF"


class WindowFunctionKind(str, Enum):
    COUNT = "COUNT"
    MEAN = "MEAN"
    SUM = "SUM"
    MIN = "MIN"
    MAX = "MAX"

    PERCENTILE_99 = "PERCENTILE_99"
    PERCENTILE_95 = "PERCENTILE_95"
    PERCENTILE_75 = "PERCENTILE_75"
    PERCENTILE_50 = "PERCENTILE_50"
    PERCENTILE_25 = "PERCENTILE_25"
    PERCENTILE_5 = "PERCENTILE_5"

    ALL_PERCENTILES = "ALL_PERCENTILES"


class GroupByKind(str, Enum):
    FEATURE_STATUS = "FEATURE_STATUS"
    FEATURE_NAME = "FEATURE_NAME"
    IS_NULL = "IS_NULL"

    RESOLVER_STATUS = "RESOLVER_STATUS"
    RESOLVER_NAME = "RESOLVER_NAME"

    QUERY_STATUS = "QUERY_STATUS"
    QUERY_NAME = "QUERY_NAME"

    ONLINE_OFFLINE = "ONLINE_OFFLINE"
    CACHE_HIT = "CACHE_HIT"

    USAGE_KIND = "USAGE_KIND"

    DEPLOYMENT_ID = "DEPLOYMENT_ID"

    OPERATION_ID = "OPERATION_ID"
    RESOURCE_GROUP = "RESOURCE_GROUP"

    POD_NAME = "POD_NAME"


class ChartLinkKind(str, Enum):
    resolver = "resolver"
    feature = "feature"
    query = "query"
    scheduled_query = "scheduled_query"
    manual = "manual"


class MetricFormulaKind(str, Enum):
    SUM = "SUM"
    TOTAL_RATIO = "TOTAL_RATIO"
    RATIO = "RATIO"
    PRODUCT = "PRODUCT"
    ABS = "ABS"
    KS_STAT = "KS_STAT"
    KS_TEST = "KS_TEST"
    KS_THRESHOLD = "KS_THRESHOLD"
    TIME_OFFSET = "TIME_OFFSET"


class AlertSeverityKind(str, Enum):
    CRITICAL = "CRITICAL"
    ERROR = "ERROR"
    WARNING = "WARNING"
    INFO = "INFO"


class ThresholdPosition(str, Enum):
    ABOVE = "ABOVE"
    BELOW = "BELOW"
    GREATER_EQUAL = "GREATER_EQUAL"
    LESS_EQUAL = "LESS_EQUAL"
    EQUAL = "EQUAL"
    NOT_EQUAL = "NOT_EQUAL"
